sasl_server_step(26 March 2000)

NAME
sasl_server_step - Perform a step in the authentication negotiation

SYNOPSIS
#include <sasl.h>

int sasl_server_step(sasl_conn_t *conn,
		          const char *clientin,
		          unsigned clientinlen,
	        	  char ** serverout,
		          unsigned * serveroutlen,
		          const char ** errstr);

DESCRIPTION
sasl_server_step() performs a step in the authentication negotiation. It returns SASL_OK if the whole negotiation is sucessful and SASL_CONTINUE if this step is ok but at least one more step is needed.

conn is the SASL connection context

clientin is the data given by the client (decoded if the protocol encodes requests sent over the wire) clientinlen is the length of clientin

serverout and serveroutlen are allocated by the library and should be sent to the client.

errstr is sometimes returned on error and gives a mechanism specific reason for failure. This information should not be given to the client.

RETURN VALUE
sasl_server_step returns an integer which corresponds to one of the following codes. SASL_CONTINUE indicates sucess and that there are more steps needed in the authentication. SASL_OK indicates that the authentication is complete. All other return codes indicate errors and should either be handled or the authentication session should be quit.

ERRORS

SASL_OK
    Success. Authentication complete

SASL_CONTINUE
    Success. Keep going.

SASL_BADVERS
    Mechanism version mismatch

SASL_BADPARAM
    Error in config file

SASL_NOMEM
    Not enough memory to complete operation

CONFORMING TO
RFC 2222

SEE ALSO
sasl(3), sasl_server_init(3), sasl_server_new(3), sasl_server_start(3)